﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private frontCamera As Boolean = False
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private imgCancelar As ImageView
	Private imgSalvar As ImageView
	Private lblData As Label
	
	
	Dim dataDiag As DateDialog
	Dim horaDiag As TimeDialog
	Private lblHora As Label
	Private edtDetalhes As EditText
	Private edtTipoRegistro As EditText
	Private imgTirarFoto As ImageView
	Private pnlFoto As Panel
	Private pnlFotoGravada As Panel
	Private imgFoto As ImageView
	
	Private camEx As CameraExClass
	
	Private situacaoFoto As String

	
	Private lblTirarFoto As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Dim ano, mes, dia, horas, minutos, segundos As String 'registro
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("NovoRegistro")
	
	
	'bug da figura do panel

	
	'Atribuindo valores de data e hora na tela
	If Main.acao = "NovoRegistro" OR Main.acao = "NovoRegistroComTipo" Then
		ano = "" & DateTime.GetYear(DateTime.Now)
		mes = "" & DateTime.GetMonth(DateTime.Now)
		dia = "" & DateTime.GetDayOfMonth(DateTime.Now)
		horas = "" & DateTime.GetHour(DateTime.Now)
		minutos = "" & DateTime.GetMinute(DateTime.Now)
		segundos = "" & DateTime.GetSecond(DateTime.Now)
		
		lblData.Text = "Data             " & padding(dia,2,0, "0") &"/"& padding(mes,2,0, "0") &"/"& ano 
		lblHora.Text = "Hora             " & padding(horas,2,0, "0") &":"& padding(minutos,2,0, "0") &":"& padding(segundos,2,0, "0")
		
	Else
	End If
	
	If Main.acao = "NovoRegistroComTipo" Then
		edtTipoRegistro.Text = buscaCampoLinhaSQL("SELECT TP.TIPO TIPO FROM ODS_CAD_TIPO_REGISTRO TP WHERE TP._ID = " & Main.idEdicao)
	End If
	pnlFoto.BringToFront
	InitializeCamera
	
	situacaoFoto = "SemFoto"
End Sub


Private Sub InitializeCamera
	camEx.Initialize(pnlFoto, frontCamera, Me, "Camera1")
	frontCamera = camEx.Front
End Sub

Sub Camera1_Ready (Success As Boolean)
	If Success Then
		camEx.SetJpegQuality(90)
		camEx.CommitParameters
		camEx.StartPreview
		Log(camEx.GetPreviewSize)
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
End Sub




Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub



Sub lblData_Click
	Dim ano, mes, dia As String
	If Main.acao = "NovoRegistro" OR Main.acao = "NovoRegistroComTipo" Then
		dataDiag.Year = DateTime.GetYear(DateTime.Now)
		dataDiag.Month = DateTime.GetMonth(DateTime.Now)
		dataDiag.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)
	
	Else
	End If
	dataDiag.Show("Selecione a data","Data","Ok","Cancelar","",Null)

	If dataDiag.Response = DialogResponse.POSITIVE Then
		ano = "" & dataDiag.year
		mes = "" & dataDiag.Month
		dia = "" & dataDiag.DayOfMonth
		lblData.Text = "Data             " & padding(dia,2,0, "0") &"/"& padding(mes,2,0, "0") &"/"& ano 
	End If
	
End Sub

Sub buscaCampoLinhaSQL(SQLSelect As String) As String
	Dim SQL1 As SQL
	Dim respostaSQL As String
	SQL1.Initialize(Main.DBFileDir, Main.DBFileName, True)

	Try
		respostaSQL = SQL1.ExecQuerySingleResult(SQLSelect)
		SQL1.Close
	Catch
		Log(LastException.message)
		Return -1000000
	End Try
		
	If respostaSQL = Null Then 
		Return -1000000
	Else
		Return respostaSQL
	End If	
	
End Sub


Sub maxIDTabela(tabela As String) As String
	Dim SQL1 As SQL
	Dim respostaSQL As String
	SQL1.Initialize(Main.DBFileDir, Main.DBFileName, True)

	respostaSQL = SQL1.ExecQuerySingleResult("Select Max (_id) + 1 MAX_ID from " & tabela)
	SQL1.Close
	If respostaSQL = Null Then 
		Return 1
	Else
		Return respostaSQL
	End If	
	
End Sub
Sub imgSalvar_Click

	Dim MAX_ID_TIPO_REGISTRO, MAX_ID_REGISTROS As Int		
	
	'checando se os campos foram preenchidos
	If edtTipoRegistro.Text = "" Then
		Msgbox ("Por favor, digite o tipo do registro!","Ajuda")
		Return
	End If
'	If edtDetalhes.Text = "" Then
'		Msgbox ("Por favor, digite os detalhes do registro!","Ajuda")
'		Return
'	End If


	If Main.acao = "NovoRegistro" Then
	
		MAX_ID_TIPO_REGISTRO = maxIDTabela("ODS_CAD_TIPO_REGISTRO")
		MAX_ID_REGISTROS = maxIDTabela("ODS_REGISTROS")

		'insert na tabela de tipo de registros
		If insertTableDB("INSERT INTO [ODS_CAD_TIPO_REGISTRO] ([_id], [TIPO]) VALUES ("&MAX_ID_TIPO_REGISTRO &" , '"&edtTipoRegistro.Text&"')") = 0 Then
			'insert na tabela de registros
			If insertTableDB("INSERT INTO [ODS_REGISTROS] ([_id], [DATA], [_ID_TIPO_REGISTRO], [DETALHES]) VALUES ("&MAX_ID_REGISTROS&" , '" & lblData.Text & " " & lblHora.Text & "', " & MAX_ID_TIPO_REGISTRO &" , '"&edtDetalhes.Text&"')") = 0 Then
				ToastMessageShow ("Registro salvo com sucesso!", True)
				Activity.Finish
			Else
				Msgbox ("Erro ao inserir o registro!","Erro")
			End If 
		Else
			Msgbox ("Erro ao inserir o registro!","Erro")
		End If
	End If


	If Main.acao = "NovoRegistroComTipo" Then
	
		MAX_ID_TIPO_REGISTRO = Main.idEdicao
		MAX_ID_REGISTROS = maxIDTabela("ODS_REGISTROS")

		'insert na tabela de registros
		If insertTableDB("INSERT INTO [ODS_REGISTROS] ([_id], [DATA], [_ID_TIPO_REGISTRO], [DETALHES]) VALUES ("&MAX_ID_REGISTROS&" , '" & lblData.Text & " " & lblHora.Text & "', " & MAX_ID_TIPO_REGISTRO &" , '"&edtDetalhes.Text&"')") = 0 Then
			ToastMessageShow ("Registro salvo com sucesso!", True)
			Activity.Finish
		Else
			Msgbox ("Erro ao inserir o registro!","Erro")
		End If 
	End If


End Sub

Sub insertTableDB(SQLInsert As String) As Int

	Dim SQL1 As SQL
	Dim respostaSQL As String
	SQL1.Initialize(Main.DBFileDir, Main.DBFileName, True)

	Try
		SQL1.ExecNonQuery(SQLInsert)
		SQL1.Close	
		Return 0
	Catch
		Log(LastException.message)
		Return 1
	End Try
	
End Sub	
Sub imgCancelar_Click

	'apagando fotos caso tenham sido tiradas
	If Main.acao = "NovoRegistro" OR Main.acao = "NovoRegistroComTipo" Then 
		Try
			File.Delete(Main.DBFileDir & "/Fotos", maxIDTabela("ODS_REGISTROS") & ".jpg")
		Catch
			Log(LastException.message)
			Return
		End Try
	End If
	
	Activity.Finish
End Sub

Sub lblHora_Click
	Dim horas, minutos, segundos As String
	If Main.acao = "NovoRegistro" OR Main.acao = "NovoRegistroComTipo" Then
		horaDiag.Hour = DateTime.GetHour(DateTime.Now)
		horaDiag.Minute = DateTime.GetMinute(DateTime.Now)
		
	
	Else
	End If
	horaDiag.Show("Selecione o horário","Horário","Ok","Cancelar","",Null)

	If horaDiag.Response = DialogResponse.POSITIVE Then
		horas = "" & horaDiag.Hour
		minutos = "" & horaDiag.Minute
		segundos = "00"
		lblHora.Text = "Hora             " & padding(horas,2,0, "0") &":"& padding(minutos,2,0, "0") &":"& padding(segundos,2,0, "0")
	End If

	
End Sub


Sub padding (palavra As String, qtd As Int, local As Int, pad As String) As String
	Dim i As Int
	Dim retorno As String
	retorno = palavra
	For i = 0 To qtd - 1
		If retorno.Length < qtd Then
			If pad = 0 Then
				retorno = pad & retorno
			Else
				retorno = retorno & pad 
			End If
		End If
	Next
	Return retorno
End Sub


Sub imgTirarFoto_Click

	If situacaoFoto = "SemFoto" Then
		camEx.TakePicture
		situacaoFoto = "ComFoto"
		
	Else
		'apagar a foto anterior ***** ' tem que ver se esta editando um lancamento.
		If Main.acao = "NovoRegistro" OR Main.acao = "NovoRegistroComTipo" Then 
			Try
				File.Delete(Main.DBFileDir & "/Fotos", maxIDTabela("ODS_REGISTROS") & ".jpg")
			Catch
				Log(LastException.message)
				Return
			End Try
		End If
'		Dim l,t,w,h As Int
'		l = pnlFoto.left
'		t = pnlFoto.Top
'		w = pnlFoto.Width
'		h = pnlFoto.Height

		
'		imgFoto.SendToBack
		'pnlFoto.Initialize("pnlFoto")
'		pnlFoto.BringToFront
		

		'Activity.AddView(pnlFoto, l,t,w,h)  'lef, top, width, heigh
		pnlFoto.BringToFront
		InitializeCamera 'camEx.StartPreview '
		situacaoFoto = "SemFoto"
		lblTirarFoto.Text = "Tirar Foto"
	End If
	
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	Dim filename As String = maxIDTabela("ODS_REGISTROS") & ".jpg"
	Dim dir As String = File.DirRootExternal & "/AP-Memoria/Fotos"
	
	camEx.SavePictureToFile(Data, dir, filename)
	'camEx.StartPreview 'restart preview
	'camEx.CloseNow
	camEx.Release
	
	'send a broadcast intent to the media scanner to force it to scan the saved file.
	Dim Phone As Phone
	Dim i As Intent
	i.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
		"file://" & File.Combine(dir, filename))
	Phone.SendBroadcastIntent(i)
	ToastMessageShow("Picture saved." & CRLF  & "File size: " & File.Size(dir, filename), True)
	
		'tratamento depois que tirar a foto
		
		Dim bd As BitmapDrawable
		bd.Initialize(LoadBitmap(Main.DBFileDir & "/Fotos",maxIDTabela("ODS_REGISTROS") & ".jpg"))
		bd.Gravity = Gravity.Fill
		pnlFotoGravada.Background = bd
		pnlFotoGravada.BringToFront
		lblTirarFoto.Text = "Nova Foto"
	
End Sub
